using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Contract;
namespace CMSMicroservice.Protobuf.Validator.Contract;

public class CreateNewContractRequestValidator : AbstractValidator<CreateNewContractRequest>
{
    public CreateNewContractRequestValidator()
    {
        RuleFor(model => model.Title)
            .NotEmpty();
        RuleFor(model => model.Description)
            .NotEmpty();
        RuleFor(model => model.HtmlContent)
            .NotEmpty();
        RuleFor(model => model.Type)
            .IsInEnum()
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewContractRequest>.CreateWithOptions((CreateNewContractRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
